//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_width1 2
#property indicator_level1 0
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT; // Time frame to use
extern int                Length   = 50;              // Cumulative momentum period
extern ENUM_APPLIED_PRICE Price    = PRICE_CLOSE;     // Price to use
extern int                MaLength = 10;              // Average period
extern ENUM_MA_METHOD     MaMethod = MODE_EMA;        // Average method
extern bool               Interpolate = true;         // Interpolate in multi time frame mode?

double mom[];
double histDn[];
double histNe[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,mom);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Cumulative momentum ("+(string)Length+","+(string)MaLength+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { mom[0] = MathMin(limit+1,Bars-1); return(0); }
         if (TimeFrame != Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
               mom[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,MaLength,MaMethod,0,y);
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                  //
                  //
                  //
                  //
                  //
                  
                  int n,k; datetime time = iTime(NULL,TimeFrame,y);
                     for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                     for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                           mom[i+k] = mom[i] + (mom[i+n] - mom[i]) * k/n;
               }
               return(0);                           
            }
      
         
         //
         //
         //
         //
         //
         

   for(int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,MaLength,0,MaMethod,Price,i);
      mom[i] = 0;
         for (int k=0; k<Length; k++) mom[i] += price-iMA(NULL,0,MaLength,0,MaMethod,Price,i+k+1);
   }
   return(0);
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
